#!/bin/bash -x

set -o nounset
set -o errexit
set -o pipefail

shopt -s extglob

if [ -f bashini.bash ]
then
    echo "using bashini.bash in local dir ($PWD)"
    source bashini.bash
else
    echo "using bashini.bash in /usr/lib/bashini/"
    source /usr/lib/bashini/bashini.bash
fi

function bashini_demo() {
    bashini_read demo $1

    echo ""
    echo "dump of keys in $1:"
    for k in "${!bashini_db_demo[@]}"
    do
	echo "encoded key='$k'"
    done

    echo ""
    echo "non existing key should fail.."
    if bashini_get_value RETVAL demo nosuch
    then
	echo "FAILURE: nosuch exists but it should not"
    else
	echo "ok"
	true
    fi

    echo "reading content of value 'mainval1' in main section.."
    bashini_get_value RETVAL demo mainval1 || echo fail mainval1
    
    echo "reading content of value 'sec2val1' in section 'sec2'.."
    bashini_get_value RETVAL demo sec2val1 sec2 || echo fail sec2val1 sec2

    echo "reading cnotent of value 'one and one' in section 'sec2'.."
    bashini_get_value RETVAL demo "one and one" sec2

    echo ""
    echo "bashini_demo ended without error code != 0"
}

echo "this is the bashini demo program (version 0.2)"

bashini_demo demo.ini
